package com.school.project.model.registration;


import com.sun.istack.NotNull;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Data
@Entity
@NoArgsConstructor
@Table(name = "users")
public class User {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "user_id")
    private Long userId;

    @NotNull
    @Column(name = "user_email", unique = true)
    private String email;

    @NotNull
    @Column(name = "user_password")
    private String password;

    @ManyToOne
    @JoinColumn(name = "role_id")
    @NotNull
    private Role role;

    @OneToOne(mappedBy = "studentAppUser", cascade = {CascadeType.MERGE})
    @PrimaryKeyJoinColumn
    private StudentReg studentUser;

//    @ElementCollection(fetch = FetchType.EAGER)
//    @CollectionTable(
//            name = "roles",
//            joinColumns = @JoinColumn(name = "user_id")
//    )
//    @Column(name = "user_role")
//    private List<String> roles; StudentReg

}
