package com.school.project.model.school;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.registration.StudentReg;
import com.school.project.model.registration.Teacher;
import lombok.AllArgsConstructor;
import lombok.Data;

import javax.persistence.*;
import java.util.List;

@Data
@Entity()
@AllArgsConstructor()
@Table(name = "Course")
public class Course {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(name = "title", unique = true)
    private String title;

    @ManyToMany(fetch = FetchType.LAZY, mappedBy = "courseLists")
    @JsonIgnore
    private List<StudentReg> studentList;

    @ManyToMany(fetch = FetchType.LAZY, mappedBy = "courseList")
    @JsonIgnore
    private List<Teacher> teacherList;

}
