package com.school.project.service.department;

import com.school.project.dto.DepartmentDTO;
import com.school.project.mapper.DepartmentMapper;
import com.school.project.repository.DepartmentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DepartmentServiceImp implements DepartmentService {
    @Autowired(required = true)
    private DepartmentRepository departmentRepository;
    @Autowired(required = true)
    private DepartmentMapper departmentMapper;

    @Override
    public DepartmentDTO saveDepartment(DepartmentDTO departmentDTO) {
        return departmentMapper.departmentModelToDTO(
                departmentRepository.save(
                        departmentMapper.departmentDTOToModel(departmentDTO)));
    }

    @Override
    public List<DepartmentDTO> readDepartment() {
        return departmentMapper.departmentListModelToDTO(departmentRepository.findAll());

    }

    @Override
    public DepartmentDTO readDepartmentById(Long departmentId) {
        return departmentMapper.departmentModelToDTO(departmentRepository.findById(departmentId).get());
    }

    @Override
    public DepartmentDTO updateDepartment(DepartmentDTO departmentDTO, Long departmentId) {
        DepartmentDTO dto = readDepartmentById(departmentId);

        dto.setName(departmentDTO.getName());

        saveDepartment(dto);

        return departmentMapper.departmentModelToDTO(departmentRepository.findById(departmentId).get());
    }

    @Override
    public void deleteDepartmentById(Long departmentId) {
        departmentRepository.deleteById(departmentId);
    }

    @Override
    public DepartmentDTO findDepartmentByName(String departmentName) {

        return departmentMapper.departmentModelToDTO(departmentRepository.findByName(departmentName));
    }


}
