package com.school.project.service.student;

import com.school.project.dto.StudentDTO;
import com.school.project.mapper.StudentMapper;
import com.school.project.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StudentServiceImp implements StudentService {
    @Autowired(required = true)
    public StudentRepository studentRepository;

    @Autowired
    public StudentMapper studentMapper;

    @Override
    public StudentDTO saveStudent(StudentDTO studentDTO) {
        return studentMapper.studentModelToDTO(
                studentRepository.save(
                        studentMapper.studentDTOToModel(studentDTO)));
    }

    @Override
    public List<StudentDTO> readAllStudents() {
        return studentMapper.studentModelToDTO(studentRepository.findAll());
    }

    @Override
    public StudentDTO readStudentById(Long id) {
        return (studentMapper.studentModelToDTO(studentRepository.findById(id).get()));
    }

    @Override
    public StudentDTO updateStudentById(StudentDTO studentDTO, Long id) {
        StudentDTO dto = studentMapper.studentModelToDTO(studentRepository.findById(id).get());

        if (studentDTO.getName() != null) {
            dto.setName(studentDTO.getName());
        }
        if (studentDTO.getAge() != null) {
            dto.setAge(studentDTO.getAge());
        }
        if (studentDTO.getCourseLists() != null) {
            dto.setCourseLists(studentDTO.getCourseLists());
        }

        return studentMapper.studentModelToDTO(
                studentRepository.save(
                        studentMapper.studentDTOToModel(dto)));
    }

    @Override
    public void deleteStudentById(Long id) {
        studentRepository.deleteById(id);
    }
}
